
#include <stdio.h>
#include <des_crypt.h>

#define SEED_SIZE	7
#define DATA_SIZE	8
#define KEY_SIZE	8



main(argc, argv)
int argc;
char *argv[];
{
    if (argc != 2) {
	fprintf (stderr, "usage is: %s host_num\n", argv[0]);
	exit (-1);
    }

    generate_password (argv[1]);
}





OLD()
{
    unsigned short seed[7];
    unsigned long val;
    int i;
    unsigned char key[8];

    for (i = 0; i < 7; i++){
	seed[i] = i*i*3;
    }

    lcong48(seed);

    for (i = 0; i < 8; i++){
	val = lrand48() % 256;
	key[i] = val;
	printf ("val %2d: %U\n", i, val);
    }
}



generate_password (host_id_str)
char *host_id_str;
{
    unsigned char key[8];
    unsigned char data[8];
    unsigned char expected_data[8];
    unsigned long hosts_id;
    unsigned mode = DES_ENCRYPT | DES_SW;
    unsigned long my_id;
    unsigned long val;
    unsigned short seed[SEED_SIZE];
    unsigned long passwd_pt1, passwd_pt2;
    int i;


    /*
     * calculate data to encrypt.
     */
    memset (data, '\0', DATA_SIZE);
    sscanf (host_id_str, "%x", &hosts_id);
    /* hosts_id = gethostid(); */
    bcopy (&hosts_id, data, sizeof(long));

    /*
     * generate the expected results of encrypted data.
     */

    
    /*
     * generate encryption key.
     */
    for (i = 0; i < 7; i++){
	seed[i] = i*i*3;
    }

    lcong48(seed);

    for (i = 0; i < KEY_SIZE; i++){
	val = lrand48() % 256;
	key[i] = val;
    }
    des_setparity(key);
    

    /* 
     * encrypt data with key, then destroy the key.
     */
    ecb_crypt(key, data, DATA_SIZE,  mode);
    memset (key, '\0', KEY_SIZE);


    /*
     * print encrypted password.
     */
    memset (&passwd_pt1, '\0', sizeof(long));
    memset (&passwd_pt2, '\0', sizeof(long));
    bcopy (&(data[0]), &passwd_pt1, 4);
    bcopy (&(data[4]), &passwd_pt2, 4);
    printf ("\nThe password is:%x %x\n", passwd_pt1, passwd_pt2);
    printf ("\nThe NSM user must type these two numbers in, INCLUDING\n");
    printf ("the space between the two numbers, at the appropriate prompt\n");
    printf ("in the run_install program.\n\n");

}

